#!/usr/local/bin/perl
#
# hosts2dns.pl - a program for generating DNS tables from host tables.
#
# 
print ";
; DNS file output from script.  DO NOT EDIT!
;
; Edit either:
;  * \{lamin\}/usr/dns/ukoln.db.head	(mail and nameserver addresses)
;  * \{lamin\}/etc/hosts		(hosts list)
;
; then type 'make' to do all the work.\n";
#
# First read in the header about mail and stuff:
open (HEAD, "ukoln.db.head");
while (<HEAD>) { print; };
close HEAD;
#
print "\n; Data from hosts file below: \n;\n"; 
#
open (HOSTS, "/etc/hosts");
while (<HOSTS>)
{
    # Reduce all whitespace to single spaces:
    s/\s+/ /g;

    # Eat up comments and print them out:
    if (s/\#(.*)$//) { print "\; $1 \n"; }

    # Ignore any lines which might now be blank:
    if (/^ *$/) { next; }

    # Add a space to the end of the line, so that add aliases terminate
    # with a space:
    $_ .= " ";

    # Get the IP address part (pardon the horredous matching
    # string for a dotted quad, ie 138.38.3.0)
    if (s/(.+?) //)
    {
	$IP = $1;

	# Grab the primary name for this address:
	if ( s/([^\.^\s]+) // )
	{
	    $priName = $1;
	    $priNameF = substr("$priName                   ", 0, 14); 
	    print "$priNameF IN \t A \t \t $IP \n";
	} else {
	    print STDERR "WARNING: No primary name for this IP address: $IP\n";
	    next;
	}

	# Now grab the aliases for this address:
LOOP:
	while (s/([^\s]+)\s//)
	{
	    $alias = $1;
	    if ($alias =~ /(.+)\.ukoln\.ac\.uk/i) {
		$alias=$1;
  	    }
	    else {
		next LOOP if ($alias =~ /\./ || $alias eq 'mail');
	    }
	    next LOOP if ($alias eq $priName);

	    $aliasF = substr("$alias                   ", 0, 14); 
	    print "$aliasF IN \t CNAME \t \t $priName\n";
	} 

    } else {
	print STDERR "WARNING: Line $_ did not appear to start with a valid address\n";
    }
}
